unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VclTee.TeeGDIPlus,
  VCLTee.Series, VCLTee.TeEngine, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Button2: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses system.Math;

var
// ό`xbZ֐ I0(x) X = 0 `15 ̒l
  I0x: array [0..15] of extended = ( Maxdouble,
                                       1.266065877752008335598,
                                       2.279585302336067267437,
                                       4.880792585865024085611,
                                      11.301921952136330449636,
                                      27.23987182360444689454,
                                      67.23440697647797532619,
                                     168.5939085102896988573,
                                     427.5641157218047851774,
                                    1093.588354511374695846,
                                    2815.71662846625447147,
                                    7288.489339821248106181,
                                   18948.92534929630886121,
                                   49444.48958221757299925,
                                  129418.5627006485636646,
                                  339649.3732979138795217
                                   );
// xbZ֐ J0(x) X = 0 `15 ̒l
  J0x: array [0..15] of extended = (   1,
                                       0.7651976865579665514497,
                                       0.2238907791412356680518,
                                      -0.2600519549019334376242,
                                      -0.3971498098638473722866,
                                      -0.1775967713143383043474,
                                       0.1506452572509969316623,
                                       0.3000792705195555966503,
                                       0.1716508071375539060909,
                                      -0.09033361118287613433595,
                                      -0.2459357644513483351978,
                                      -0.1711903004071960883458,
                                       0.04768931079683353662381,
                                       0.2069261023770678109966,
                                       0.1710734761104586590631,
                                      -0.01422447282678077323386
                                      );

//xk[CB(2)AB(4)AB(6)A...AB(20)

  B : array[1..10] of extended = ( 1.0 / 6,           // B(2)
                                  -1.0 / 30,
                                   1.0 / 42,
                                  -1.0 / 30,
                                   5.0 / 66,
                                -691.0 / 2730,
                                   7.0 / 6,
                               -3617.0 / 510,
                               43867.0 / 798,
                             -174611.0 / 330);        //  B(20)

function loggamma(x: extended): extended;  // K}֐̑ΐ
var
  log_2pis2 : extended;
	v, w: extended;
begin
  log_2pis2 := ln(2 * pi) / 2;
	v := 1;
	while x < 10 do begin            // xk[C̐ɂxl␳܂
    v := v * x;
    x := x + 1;
  end;
	w := 1 / (x * x);
	result := (((((((((
                B[10] / (20 * 19)  * w + B[9] / (18 * 17)) * w
              + B[8]  / (16 * 15)) * w + B[7] / (14 * 13)) * w
	            + B[6]  / (12 * 11)) * w + B[5] / (10 *  9)) * w
	            + B[4]  / ( 8 *  7)) * w + B[3] / ( 6 *  5)) * w
	            + B[2]  / ( 4 *  3)) * w + B[1] / ( 2 *  1)) / x
	            + log_2pis2 - ln(v) - x + (x - 1 / 2) * ln(x);
end;
//--------------------------------------------------------------

function gamma(x: extended): extended;  // K}֐
begin
  if x < 0 then begin
    result := pi / (sin(pi * x) * exp(logGamma(1 - x)));
  end
  else begin
    result := exp(LogGamma(x));
  end;
end;

//==============================================================================
//----------------------- new --------------------------------------------------
// X l
// v 
// flag false ʏ true ό`
function Jvx(v, x: extended; flag: boolean): extended;
var
  k : integer;
  g, j, bkk, n: extended;

  function Bk(k : integer): extended;
  var
    kn : integer;
    Bn, Y, Zk: extended;
  begin
    Y := -(x / 2) * (x / 2);
    if flag then Y := -Y;
    Bn := 1;
    for kn := 1 to k do begin
      Zk := Y / (kn * (kn + v));
      Bn := Zk * Bn;
    end;
    result := Bn
  end;

begin
  n := round(v);
  if (n = v) and (n < 0) then v := abs(v);
  g := gamma(1 + v);
  bkk := 0;
  for k := 0 to 100 do  bkk := bkk + Bk(k);
  j := power(x / 2, v) / g * bkk;
  if (not flag) and (abs(n) = v) and (n < 0) then j := j * Power(-1, v);
  result := j;
end;

//-------------------@old -----------------------------------------------------
// X l
// v 
// flag false ʏ true ό`
function Bessel1(X: extended; v: extended;  flag: boolean): extended;
const
  Mn = 100;
var
  M : Integer;
  B, S, n: extended;
begin
  n := round(v);
  if (n = v) and (n < 0) then v := abs(v);
  S := 0;
  for M := 0 to MN do begin
    B := 1 / Gamma(M + 1) / Gamma(M + v + 1);   // B = 1 / ((m + 1)(m + n + 1))
    if not flag then
      S := S + power(-1, M) * B * power(X / 2, 2 * M + v)
    else
      S := S + B * power(X / 2, 2 * M + v)
  end;
  if (not flag) and (abs(n) = v) and (n < 0) then S := S * Power(-1, v);
  result := S;
end;

//==============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  jk : extended;
  v, x, dx: extended;
  i, n : integer;
  flag : boolean;
begin
  flag := false;
  if checkbox2.Checked = true then flag := true;
  memo1.Clear;
  val(labelededit1.Text, v, i);
  if i <> 0 then begin
    memo1.Lines.Append('v̒lɊԈႢ܂B');
    exit;
  end;
  val(labelededit2.Text, x, i);
  if i <> 0 then begin
    memo1.Lines.Append('x̒lɊԈႢ܂B');
    exit;
  end;
  {$IFDEF CPUX64}
  Memo1.Lines.Append('X64 double');
  {$ELSE}
  Memo1.Lines.Append('X86 extended');
  {$ENDIF}
  if checkbox1.Checked = true then jk := Bessel1(x, v, flag)
                               else jk := jvx(v, x, flag);
  if checkbox2.Checked = false then memo1.Lines.Append('xbZ֐')
                               else memo1.Lines.Append('ό`xbZ֐');
  memo1.Lines.Append('');

  if checkbox2.Checked = false then memo1.Lines.Append('Jv(x) = ' + floatTostr(jk))
                               else memo1.Lines.Append('Iv(x) = ' + floatTostr(jk));
  chart1.Title.Text.Clear;
  if checkbox2.Checked = false then chart1.Title.Text.Append('xbZ֐')
                               else chart1.Title.Text.Append('ό`xbZ֐');
  chart1.LeftAxis.Title.Caption := '';
  Series1.Clear;
  Series2.Clear;
  Series2.AddXY(x, jk);
  dx := 0.02;
  n := 750;
  if checkbox2.Checked = true then n := round((x + 1) / dx);
  for i := 0 to n do begin
    x := i * dx;
    if checkbox1.Checked = true then jk := Bessel1(x, v, flag)
                                else jk := jvx(v, x, flag);
    Series1.AddXY(x, jk);
  end;
end;

// J0(x) X=0`15̒ľ덷̌vZ
procedure TForm1.Button2Click(Sender: TObject);
var
  flg: boolean;
  i, p, l: integer;
  jk: extended;
  def : extended;
  defs, re, ex, ads, no : string;
begin
  memo1.Clear;
  Series1.Clear;
  Series2.Clear;
  {$IFDEF CPUX64}
  chart1.LeftAxis.Title.Caption := 'xxE12';
  Memo1.Lines.Append('X64 double');
  {$ELSE}
  chart1.LeftAxis.Title.Caption := 'xxE15';
  Memo1.Lines.Append('X86 extended');
  {$ENDIF}
  flg := False;
  if checkbox2.Checked = true then flg := true;
  for i := 0 to 15 do begin
    if checkbox1.Checked = true then jk := Bessel1(i, 0, flg)
                                else jk := jvx(0, i, flg);
    if flg and (i = 0) then def := 0
                       else begin
                        if flg then def := abs(I0x[i] - jk)
                               else def := abs(J0x[i] - jk);
                       end;
    {$IFDEF CPUX64}
    Series1.AddXY(i, def * 1E12);
    {$ELSE}
    Series1.AddXY(i, def * 1E15);
    {$ENDIF}
    if def <> 0 then
      defs := floatTostr(def)
    else defs := '      0';

    l := length(defs);
    p := pos('E', defs, 1);
    re := copy(defs, 0, 4);
    ex := copy(defs, p, l - p + 1);
    no := inttostr(i);
    if i < 10 then no := '  ' + no;
    if i mod 2 = 0 then
      ads := no + '  ' + re + ex
    else begin
      ads := ads + '      ' + no + '  ' + re + ex;
      if i = 15 then memo1.Lines.Text := memo1.Lines.Text + ads
      else memo1.Lines.Append(ads);
    end;
  end;
end;

end.

