// X̒l@ϕvZ̏lMNɂăI[o[t[𔭐̂
// RpCݒɃI[o[t[`bNK{łB
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VclTee.TeeGDIPlus,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  system.UITypes;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    CheckBox1: TCheckBox;
    LabeledEdit2: TLabeledEdit;
    Series2: TLineSeries;
    LabeledEdit3: TLabeledEdit;
    Series3: TLineSeries;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    function gamma(z: double): double;
    procedure Besselgraph(n: integer; Xmax: double; flag: boolean);
    function Bessel(X: double; N: integer;  flag: boolean): double;
    function BesselG(X: double; v: double;  flag: boolean): double;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses math;

var
  MN : integer;                 // ϕl


//-----------------------------------------------------------------------------
// Gamma_Function(x)
function TForm1.gamma(z: double): double;
const
  P: array[0..7] of double =
        ( 676.5203681218851,   -1259.1392167224028,       771.32342877765313,
         -176.61502916214059,     12.507343278686905,      -0.13857109526572012,
            9.9843695780195716e-6, 1.5056327351493116e-7);
  max_double_z: double = 171.0;
var
  i : integer;
  a, t : double;
begin
  if z > max_double_z then begin
    result := maxdouble;
    exit;
  end;
  if z < 0.5 then begin
    result := pi / (sin(pi * z) * gamma(1 - Z));
    exit;
  end;
  z := z - 1;
  a := 0.99999999999980993;
  for i := 0 to length(p) - 1 do a := a + p[i] / (z + i + 1);
  t := z + length(p) - 0.5;
  result := sqrt(2 * pi) * power(t, z + 0.5) * exp(-t) * a;
end;
//*****************************************************************************

//-----------------------------------------------------------------------------

// xbZ֐ ֐gp
// X l
// v 
// flag false ʏ true ό`
function TForm1.BesselG(X: double; v: double;  flag: boolean): double;
var
  M : Integer;
  B, S  : double;
begin
  S := 0;
  for M := 0 to MN do begin
    B := 1 / Gamma(M + 1) / Gamma(M + v + 1);   // B = 1 / ((m + 1)(m + n + 1))
    if not flag then
      S := S + power(-1, M) * B * power(X / 2, 2 * M + v)
    else
      S := S + B * power(X / 2, 2 * M + v)
  end;
  result := S;
end;

// xbZ֐
// X l
// N 
// flag false ʏ true ό`
function TForm1.Bessel(X: double; N: integer;  flag: boolean): double;
var
  J, K: Integer;
  B, S, Jf: double;
begin
  B := 1.0;
  if N > 1 then begin
    for K := 1 to N do B := B / K;
  end;
  S := B * power((X / 2), N);                     // j = 0
  for J := 1 to MN do begin
    Jf := J;                                      // I[o[t[΍ŕ_gp܂
    B := B / (Jf * (Jf + N));                     // b / m!(m + n)!
    if not flag then
      S := S + power(-1, J) * B * power(X / 2, 2 * J + N)
    else
      S := S + B * power(X / 2, 2 * J + N)
  end;
  result := S;
end;

// xbZ֐ Ot\
// n 
// Xmax Otől
// flag false ʏ true ό`
procedure TForm1.Besselgraph(n: integer; Xmax: double; flag: boolean);
const
  NMAX = 1000;
var
  Y, X: array of double;
  I : integer;
  XMIN: double;
begin
  setlength(X, NMAX);
  setlength(Y, NMAX);
  XMIN := 0;
  for I := 0 to NMAX - 1 do begin
    X[I] := XMIN + (XMAX - XMIN) * I / NMAX;
    if checkbox2.Checked = False then
      Y[I] := Bessel(x[I], n, flag)                // xbZ֐
    else
      Y[I] := BesselG(x[I], n, flag);              // K}֐gpxbZ֐
  end;
  for I := 0 to NMAX - 1 do begin
    if n = 0 then Series1.AddXY(X[I], Y[I]);
    if n = 1 then Series2.AddXY(X[I], Y[I]);
    if n = 2 then Series3.AddXY(X[I], Y[I]);
  end;
end;


// xbZ֐vZ
procedure TForm1.Button1Click(Sender: TObject);
var
  ch: integer;
  X : double;
  Flg: boolean;
begin
  val(LabeledEdit2.Text, X, Ch);
  if ch <> 0 then begin
    MessageDlg('XlɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  val(LabeledEdit3.Text, MN, Ch);
  if ch <> 0 then begin
    MessageDlg('ϕɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  Chart1.Title.Text.Clear;
  if checkbox1.Checked = False then begin
    Flg := False;
    Chart1.Title.Text.Add('PxbZ֐');
  end
  else begin
    Flg := True;
    Chart1.Title.Text.Add('Pό`xbZ֐');
  end;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Besselgraph(0, X, Flg);
  Besselgraph(1, X, Flg);
  Besselgraph(2, X, Flg);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label1.Caption := 'l傫߂' + #13#10 + 'I[o[t[܂B';
end;


end.
